using System;
using System.Drawing;
using System.Windows.Forms;
using OpenMetaverse;

namespace SLClientDemo
{
	public partial class MainForm : Form
	{
		// GridClient is the primary class the library uses for almost all things
  		private static GridClient Client = new GridClient();			
  		
		public MainForm()
		{
			InitializeComponent();
		}
		
		void LoginSLButtonClick(object sender, EventArgs e)
		{
			// Client.Network.Login("Avatar FirstName",
  			//  "Avatar LastName", "Avatars Password", "FirstBot", "1.0")
   			if (Client.Network.Login("MyTestBot", "Resident",
       		                         "PippoPluto", "FirstBot", "1.0")) {
    			// Yay we made it! let's print out the message of the day
    			SLTextBox.Text = "You have successfully logged into Second Life!" +
            	                 "\n The Message of the day is " +
            		             Client.Network.LoginMessage;    			
   			} else 
   			{
    			// tell the user why the login failed
    			SLTextBox.Text = "We were unable to login to Second Life, " +
                			     "The Login Server said: " +
                    		 	 Client.Network.LoginMessage;
   			}
		}
		
		void LogoutSLButtonClick(object sender, EventArgs e)
		{
			Client.Network.Logout(); // Lets logout since we're done here
			SLTextBox.Text = "Logout Successfully.";
		}
		
  		private static GridClient OSClient = new GridClient();
		
		void LoginOSButtonClick(object sender, EventArgs e)
		{			
  			LoginParams loginParams;			
			loginParams = OSClient.Network.DefaultLoginParams(
  				"MyTestBot", "Resident", "PippoPluto", "FirstBot", "1.0");
   			loginParams.AgreeToTos = true;
   			loginParams.URI = "https://login.agni.lindenlab.com/cgi-bin/login.cgi";
   			if (OSClient.Network.Login(loginParams)) {
   				OSClient.Self.Movement.AlwaysRun = false;
    			OSTextBox.Text = "Successfully logged in.\n " 
    				             + OSClient.Network.LoginMessage;
   			} else 
   			{
    			OSTextBox.Text = "We were unable to login.\n " 
    				             + OSClient.Network.LoginMessage;
   			}		
		}
		
		void LogoutOSButtonClick(object sender, EventArgs e)
		{
			OSClient.Network.Logout();
			OSTextBox.Text = "Logout Successfully.";
		}
		
		void InfoButtonClick(object sender, EventArgs e)
		{
			if (Client.Settings.SEND_AGENT_UPDATES) {    			
				SimPosTextBox.Text = "Sim pos: " + Client.Self.SimPosition.ToString();
				SimXPosTextBox.Text = "X: " + (int)Client.Self.SimPosition.X;
				SimYPosTextBox.Text = "Y: " + (int)Client.Self.SimPosition.Y;
				SimZPosTextBox.Text = "Z: " + (int)Client.Self.SimPosition.Z;
				SimNameTextBox.Text = "Sim name: " + Client.Network.CurrentSim.Name.ToString();
				SimOwnerTextBox.Text = "Sim owner: " + Client.Network.CurrentSim.SimOwner.ToString();
				AvatarNameTextBox.Text = "Avatar name: " + 
					                     Client.Self.FirstName + " " + Client.Self.LastName;
   			}			
		}
	}
}
